<component-section>
  <div slot="title">🔀 Sorteren</div>
  <component-section>
    <div slot="title">Waarom je over sorteren leert</div>
    <p>Sorteren/gesorteerdheid ligt aan de basis van de meeste praktische algoritmes.</p>
    <p class="praktijk">
      Databasesystemen zoals
      <a href="https://www.postgresql.org/docs/13/queries-order.html">PostgreSQL</a>
      kunnen data van hetzelfde type (bijvoorbeeld een kolom) sorteren, zodat snel zoeken mogelijk is.
    </p>
    <p class="praktijk">
      In tegenstelling tot vele andere (standaard)algoritmes, zijn sorteeralgoritmes is niet alleen een bouwsteen voor
      complexere algoritmes, maar zeker ook rechtstreeks relevant voor functionele vereisten. Denk aan een
      spreadsheet-app, waarin je wilt kunnen sorteren.
    </p>
  </component-section>
  <component-section>
    <div slot="title">Binary search</div>
    <p>
      Om een rij te kunnen sorteren, is allereerst van belang dat de element van de rij <em>vergelijkbaar</em> zijn (een
      totale ordening hebben). Laten we beginnen met een voorbeeld van het nut van een gesorteerde rij.
    </p>
    <p>
      <em class="term">Binary search</em> is een eenvoudig algoritme voor efficiënt <em>zoeken</em> naar een element in
      een al gesorteerde rij. Binary search heeft in het gemiddelde en slechtste geval een betere looptijd (van
      \(O(\log(n))\)) dan <em class="term">linear search</em> (van \(O(n)\)).
    </p>
    <p>Als de rij gesorteerd is kan je daardoor dus het schaalbaardere binary search gebruiken voor zoeken.</p>
    <p><em>Binary</em> verwijst overigens naar het opdelen van de rij in telkens twee deelrijen.</p>
    <p class="bron">Binary Search - Algorithm and Pseudo-code</p>
    <component-video videoid="2BhQxgIgXX4" title="Binary Search - Algorithm and Pseudo-code"></component-video>
    <p class="bron">
      <a href="https://opendsa.cs.vt.edu/ODSA/Books/Everything/html/BinarySearch.html">Searching in an Array</a>
    </p>
  </component-section>
  <component-section>
    <div slot="title">Insertion sort</div>
    <p>
      <em class="term">Insertion sort</em> is een eenvoudig sorteeralgoritme, dat lijkt op hoe spelers van kaartspelen
      vaak hun kaarten in de hand sorteren.
    </p>
    <p class="bron">Insertion Sort Algorithm</p>
    <p>OpenDSA bevat een handige visualisatie en de broncode:</p>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/Everything/html/InsertionSort.html">Insertion Sort</a>
    </p>
    <p>Rosetta Code bevat veel voorbeeldimplementaties in talloze programmeertalen:</p>
    <p class="bron">
      <a href="https://rosettacode.org/wiki/Sorting_algorithms/Insertion_sort">Sorting algorithms/Insertion sort</a>
    </p>
    <p>
      Insertion sort is nog steeds een eenvoudig algoritme, en heeft ook weer een looptijd in het gemiddelde en
      slechtste geval van maar liefst \(Θ(n^2)\). Insertion sort heeft wel een goede looptijd van \(Θ(n)\) in het beste
      geval, omdat deels al gesorteerde deelrijen de benodigde looptijd omlaag brengen. Het beste geval is echter lastig
      voorspelbaar, dus maakt insertion sort niet veel aantrekkelijker.
    </p>
  </component-section>
  <component-section>
    <div slot="title">Selection sort</div>
    <p>
      <em class="term">Selection sort</em> houdt in het telkens zoeken naar het grootste nog ongesorteerde element in de
      lijst. Dat element wisselt selection sort telkens om. Dat grootste nog ongesorteerde element wordt omgewisseld met
      het element vóór het laatste al gesorteerde element. De eerste wisseling moet zijn: wissel het grootste element
      met het laatste element uit de lijst. De lijst wordt vervolgens van het einde van de lijst richting het begin
      gesorteerd. Selection sort kan natuurlijk ook geïmplementeerd worden door naar het <em>kleinste</em> element te
      zoeken en van voren af aan te sorteren. Het algoritme zou daardoor niet wezenlijk anders zijn en heet daarom ook
      selection sort.
    </p>
    <p>OpenDSA bevat een handige visualisatie en de broncode:</p>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/Everything/html/SelectionSort.html">Selection Sort</a>
    </p>
    <p>
      Selection sort is weliswaar een eenvoudig algoritme, maar heeft in alle gevallen een looptijd van maar liefst
      \(Θ(n ^ 2)\), vanwege de groei van het aantal <em>vergelijkingen</em> tussen elementen naarmate de lijst langer
      is. Het aantal vergelijkingen groeit snel doordat voor ieder ander element (en er zijn er \(n - 1\)) het grootste
      nog ongesorteerde element moet worden gezocht (door het \(n - 1 - \text{aantal}_\text{gesorteerd}\) keer te
      vergelijken). Dit is uit te drukken als \(\frac{1}{2}n(n-1)=\frac{1}{2}(n ^ 2 - n)\) vergelijkingen, en dat wordt
      in algoritmeanalyse vereenvoudigd tot een groeiorde van \(n ^ 2\). Het aantal <em>wisselingen</em> kan wel lager
      uitpakken als de data vooraf al gesorteerd was, maar beide soorten instructies tellen en beschouwen we als even
      zwaar binnen het machinemodel. De begrenzing is ook \(Θ(\cdot)\), dus strikter dan \(O(\cdot)\), omdat het aantal
      vergelijkingen niet langzamer of sneller groeit in verhouding tot verschillende mogelijke invoergroottes. Het
      aantal vergelijkingen groeit evenmin langzamer of sneller in verhouding tot mogelijke inhouden van de lijst
      (bijvoorbeeld een al gesorteerde versus een ongesorteerde lijst), dus de groeiorde en begrenzing gelden inderdaad
      <em>in alle gevallen</em>.
    </p>
  </component-section>
  <component-section>
    <div slot="title">Merge sort</div>
    <p>
      <em class="term">Merge sort</em> is een sorteeralgoritme met in alle gevallen een looptijd van \(Θ(n \log(n)\),
      wat beter is dan de eerder vermelde gemiddelde en slechtste gevallen van insertion en selection sort.
    </p>
    <p>
      Merge sort is gebaseerd op divide-and-conquer. Je kan merge sort recursief of iteratief formuleren en
      implementeren, maar veel basisuitleg gaat uit van een recursieve formulering.
    </p>
    <p>Jeff Erickson legt het algoritme en zijn geschiedenis uit:</p>
    <p class="bron">
      <a href="http://jeffe.cs.illinois.edu/teaching/algorithms/book/01-recursion.pdf">Mergesort</a>
      <cite data-id="6867189/PLHZEH2X" data-label="section" data-locator="1.4"></cite>
      (bewijzen behoren niet tot ADP)
    </p>
    <p>OpenDSA bevat een handige visualisatie en voorbeeldbroncode:</p>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/Everything/html/Mergesort.html">Mergesort Concepts</a>
    </p>
    <p class="bron">Merge Sort 1 - The Algorithm</p>
    <component-video videoid="M5kMzPswo20" title="Merge Sort 1 - The Algorithm"></component-video>
    <p>Rosetta Code bevat veel voorbeeldimplementaties in talloze programmeertalen:</p>
    <p class="bron">
      <a href="https://rosettacode.org/wiki/Sorting_algorithms/Merge_sort">Sorting algorithms/Merge sort</a>
    </p>
    <component-section>
      <div slot="title">Waarom je merge sort leert</div>
      <p>
        In Java SE 14 wordt een variant van merge sort als standaardimplementatie van
        <code class="hljs lang-java">List.sort()</code>
        gebruikt. Het is dus zeker een standaardalgoritme.
      </p>
      <p class="bron">
        <a
          href="https://docs.oracle.com/en/java/javase/14/docs/api/java.base/java/util/List.html#sort(java.util.Comparator)"
          ><code class="hljs lang-java">List.sort()</code> API docs</a
        >.
      </p>
    </component-section>
  </component-section>
  <component-section>
    <div slot="title">Quicksort</div>
    <p>
      Quicksort is een algoritme dat in de praktijk vaak gebruikt wordt, omdat het in het gemiddelde geval een goede
      looptijd heeft van \(O(n \log(n))\).
    </p>
    <p>
      Quicksort is ook het meest complexe sorteeralgoritme dat we behandelen, omdat er veel details in zitten die tussen
      implementaties kunnen verschillen. Bovendien wordt in de praktijk in Quicksortimplementaties ook een ander
      sorteeralgoritme als insertion sort aangeroepen zodra een deelrij erg klein is, want dan weegt de lage constante
      overhead van insertion sort zwaarder dan zijn in het gemiddelde geval slechte complexiteitscategorie.
    </p>
    <p>
      Net als merge sort is Quicksort gebaseerd op divide-and-conquer. Je kan Quicksort eveneens recursief of iteratief
      formuleren en implementeren, maar veel basisuitleg gaat uit van een recursieve formulering.
    </p>
    <p>Jeff Erickson legt het algoritme en zijn geschiedenis uit:</p>
    <p class="bron">
      <a href="http://jeffe.cs.illinois.edu/teaching/algorithms/book/01-recursion.pdf">Quicksort</a>
      <cite data-id="6867189/PLHZEH2X" data-label="section" data-locator="1.5-1.6"></cite>
      (bewijzen behoren niet tot ADP)
    </p>
    <p>OpenDSA bevat een handige visualisatie en voorbeeldbroncode:</p>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/Quicksort.html">Quicksort</a>
    </p>
    <p class="bron">Quicksort 1 - The Algorithm</p>
    <component-video videoid="h_9kAXFKJwY" title="Quicksort 1 - The Algorithm"></component-video>
    <p>
      Net als bij merge sort kan je van Quicksort een goed leesbare recursieve implementatie uitprogrammeren, of een
      slechter leesbare maar in de praktijk efficiëntere iteratieve.
    </p>
    <p class="bron">Quicksort 2 - Alternative Algorithm</p>
    <component-video videoid="O5V5JTa3O20" title="Quicksort 2 - Alternative Algorithm"></component-video>
    <p class="bron">Merge Sort: Top-Down and Bottom-Up</p>
    <component-video videoid="k3oezbZgfDs" title="Merge Sort: Top-Down and Bottom-Up"></component-video>
    <p class="bron">Quick Sort and Quick Select</p>
    <component-video videoid="v-1EGgaTFuw" title="Quick Sort and Quick Select"></component-video>
    <p class="bron">Linear Time Sorting: Counting Sort, Radix Sort, and Bucket Sort</p>
    <component-video
      videoid="pJ1IQD5rv4o"
      title="Linear Time Sorting: Counting Sort, Radix Sort, and Bucket Sort"></component-video>
    <p>Rosetta Code bevat veel voorbeeldimplementaties in talloze programmeertalen:</p>
    <p class="bron">
      <a href="https://rosettacode.org/wiki/Sorting_algorithms/Quicksort">Quicksort</a>
    </p>
    <component-section>
      <div slot="title">Pivot</div>
      <p>
        Alleen de naam van het algoritme, ‘Quicksort’, zegt vergeleken met de meeste standaardalgoritmes erg weinig. De
        manier waarop de
        <em class="term">pivot</em> wordt gekozen is cruciaal, maar wordt in allerlei varianten van quicksort anders
        ingevuld. Dat met goede reden, want de invoerdata kan bijvoorbeeld verschillen voor toepassen. Van alle manieren
        zijn er gelukkig maar enkele overgebleven die betrouwbaar bleken. Als het gaat om het aantal pivots:
      </p>
      <ul>
        <li>Enkele</li>
        <li>Dubbele</li>
      </ul>
      <p>En als het gaat om de keuze van de pivotwaarde:</p>
      <ul>
        <li>Random</li>
        <li>Middelste</li>
      </ul>
    </component-section>
    <p>In het slechtste geval heeft Quicksort een looptijd van \(O(n^2)\).</p>
    <component-section>
      <div slot="title">Waarom je Quicksort leert</div>
      <p>
        In Java SE 14 wordt een variant van Quicksort als standaardimplementatie van
        <code class="hljs lang-java">Arrays.sort()</code>
        gebruikt. Het is dus zeker een standaardalgoritme.
      </p>
      <p class="bron">
        <a href="https://docs.oracle.com/en/java/javase/14/docs/api/java.base/java/util/Arrays.html#sort(int%5B%5D)"
          ><code class="hljs lang-java">Arrays.sort()</code> API docs</a
        >
      </p>
    </component-section>
  </component-section>
  <component-section extra>
    <div slot="title">Complexiteitscategorie bij lijsten in het algemeen</div>
    <p>
      Tot nu toe hebben we het over het sorteren van rijen gehad, niet over lijsten in het algemeen. Insertion sort en
      Quicksort hebben een slechtere complexiteitscategorie op linked lists dan op rijen, omdat elementen niet in
      constante looptijd benaderd kunnen worden (zoals met indexeren in een rij wel kan). Een extreme oplossing zou
      kunnen zijn het omzetten van de linked list naar een rij, sorteren met bijvoorbeeld Quicksort, en de rij weer
      omzetten naar een linked list. Dat heeft een looptijd van \(O(n) + O(n \log(n)) + O(n)\), wat nog steeds beter is
      dan \(O(n^2)\). Een eenvoudige oplossing is het besef dat als je een linked list moet gaan sorteren, je misschien
      niet de beste datastructuur voor je algoritme hebt gekozen.
    </p>
    <p>
      Mocht je toch benieuwd zijn hoe verscheidene sorteeralgoritmes het doen op linked lists, lees dan
      <a href="https://citeseerx.ist.psu.edu/viewdoc/download?doi=10.1.1.83.3116&rep=rep1&type=pdf"
        >A comparative study of linked list sorting algorithms</a
      >.
    </p>
  </component-section>
  <component-section>
    <div slot="title">
      <a href="https://ans.app/digital_test/assignments/297670/routing"
        >Keuzeproces Java SE 17 voor sorteeralgoritmes (op Ans)</a
      >
    </div>
    <component-exercise></component-exercise>
  </component-section>
</component-section>
